program ExampleStack;
  {-Example program to show how to use a stack to walk a DOS directory
    tree without using recursion.
    Normally this would be done along these lines:

        procedure ListDirs(Dir : string);
          var
            SR : SearchRec;
          begin
            FindFirst(Dir+'\*.*', SR, Directory);
            while (DOSError = 0) do
              begin
                if (



uses
  EZStrucs;





var
  StartMem : longint;
  i   : integer;
  S   : string;

begin
  {get the initial memory available}
  StartMem := MemAvail;

  {initialise the stack}
  if not Stk.Init then
    begin
      writeln('Error during string stack Init');
      Halt;
    end;

  {push some strings onto the stack}
  for i := 1 to 10 do
    begin
      Str(i, S);
      Stk.Push(S);
    end;

  {pop the strings off, and write them out}
  for i := 1 to 10 do
    writeln(Stk.Pop);

  {destroy the stack}
  Stk.Done;

  {check that all the memory was released}
  if (MemAvail <> StartMem) then
    writeln('Warning: memory left allocated on the heap');
end.
